function [fmoy,fmed] = estim_DSP_2(x,fe,flim);

% function estim_DSP(x,fe,flim);
% affiche l'estimation de la DSP du signal x
% fe frquence d'chantillonnage
% flim limite de frquence pour la reprsentation

L = length(x);
[Px,f] = pwelch(x-mean(x),L/2,[ ],[ ],fe);
Ind = find(f<=flim);

fmoy = f'*Px/sum(Px);
V = cumsum(Px);
fmed = f(min(find(V>sum(Px)/2)));

plot(f(Ind),Px(Ind));
xlabel('Hz')
hold on
vy = get(gca,'Ylim');
plot(fmoy*ones(2,1),vy,'r',fmed*ones(2,1),vy,'g')
title('bleu: DSP, rouge: freq. moyenne, vert: freq. mediane')
hold off




